$compile unit

$error all-
$lib all-

defint a-z



'mins% - Returns time in minutes from midnight
'written by Dave Navarro

FUNCTION mins%(Tim$)  Public
   mins%=VAL(LEFT$(Tim$,2))*60+VAL(MID$(Tim$,4,2))
END FUNCTION

'Elapsed% - Returns the number of minutes elapsed between two times
'written by Dave Navarro

FUNCTION Elapsed%(Tim1$, Tim2$)  Public
   Tim1%=mins%(Tim1$)
   Tim2%=mins%(Tim2$)
   IF Tim2%<Tim1% THEN Tim2%=Tim2%+1440
   Elapsed%=Tim2%-Tim1%
END FUNCTION

'FFeed - Send a formfeed to the printer
'written by Dave Navarro

SUB FFeed PUBLIC
   LPRINT CHR$(12)
END SUB

'Found on CIS in the TB conference
' Comment : Compaq 386 machines have the date offset by one.
'           Substitute &HFFF5 to &HFFFC in that case.

FUNCTION RomDate$ STATIC  Public
  LOCAL Temp$
  DEF SEG = &HF000
  RomDate$ = PEEK$(&hFFF5, 10)
  DEF SEG
END FUNCTION


'Atrb - Return a printable string describing a files attributes

FUNCTION Atrb$(X$) PUBLIC
  X$=remove$(X$," ")
  IF X$="" OR X$="." OR RIGHT$(X$,1)="\" OR RIGHT$(X$,3)="\.." THEN EXIT FUNCTION
  X%=ATTRIB(X$)
  IF (X% AND 1)=1 THEN Tmp$=Tmp$+"R" ELSE Tmp$=Tmp$+"."
  IF (X% AND 2)=2 THEN Tmp$=Tmp$+"H" ELSE Tmp$=Tmp$+"."
  IF (X% AND 4)=4 THEN Tmp$=Tmp$+"S" ELSE Tmp$=Tmp$+"."
  IF (X% AND 32)=32 THEN Tmp$=Tmp$+"A" ELSE Tmp$=Tmp$+"."
  Atrb$=Tmp$
END FUNCTION

'Attrb - Turns a printable string containing attributes into an integer

FUNCTION Attrb%(Atr$) PUBLIC
   Atr$=UCASE$(Atr$)
   IF INSTR(Atr$,"A") THEN Tmp%=Tmp%+32
   IF INSTR(Atr$,"R") THEN Tmp%=Tmp%+1
   IF INSTR(Atr$,"H") THEN Tmp%=Tmp%+2
   IF INSTR(Atr$,"S") THEN Tmp%=Tmp%+4
   Attrb%=Tmp%
END FUNCTION


'DayWeek% - Returns the day of the week (1-7) for the current date
'Idea from Berry Erick

FUNCTION DayWeek%(Dat$)  Public
   Temp$=DATE$
   DATE$=Dat$
   REG 1, &h2A00
   DayWeek%=REG(1) MOD 256
   DATE$=Temp$
END FUNCTION


'SetVerify% - Set DOS verify flag, 0 = Off, 1 = On

FUNCTION SetVerify%(Status%) PUBLIC
  REG 1, &h2E00+Status%
  CALL INTERRUPT &h21
  SetVerify%=GetVerify%
END FUNCTION

'GetVerify% - Get DOS verify flag, 0 = Off, 1 = On

FUNCTION GetVerify% PUBLIC
  REG 1, &h5400
  CALL INTERRUPT &h21
  GetVerify%=REG(1) AND &H00FF
END FUNCTION


'MakeDir - Like MKDIR command, only returns an error code if not succesful
'          3 = Path not found,  5 = Access Denied

FUNCTION MakeDir%(DirName$) PUBLIC
  Tmp$=DirName$+CHR$(0)
  REG 1, &H3900
  REG 8, STRSEG(Tmp$)
  REG 4, STRPTR(Tmp$)
  CALL INTERRUPT &H21
  IF (REG(0) AND &H0001)=1 THEN MakeDir%=REG(1)
END FUNCTION

'RemoveDir - Like RMDIR command, only returns an error code if not successful
'            3 = Path no found, 5 = Access Denied, 6 = Current Directory

FUNCTION RemoveDir%(DirName$) PUBLIC
  Tmp$=DirName$+CHR$(0)
  REG 1, &H3A00
  REG 8, STRSEG(Tmp$)
  REG 4, STRPTR(Tmp$)
  CALL INTERRUPT &H21
  IF (REG(0) AND &H0001)=1 THEN RemoveDir%=REG(1)
END FUNCTION


'NumRecs - Returns the total number of records within a file

FUNCTION NumRecs&(Fil$,RecSize%) PUBLIC

    a$=dir$(fil$)
    if a$="" then exit function
    FileHand%=FREEFILE
    OPEN "R",FileHand%,Fil$,RecSize%
      TotalRecs&=LOF(FileHand%)/RecSize%
    CLOSE FileHand%
    NumRecs&=TotalRecs&
END FUNCTION

'PutRec - Put a record to a file

SUB PutRec(Fil$,RecNum%,RecSize%,Rec$) PUBLIC
    IF RecNum%<1 THEN EXIT SUB
    IF Rec$="" THEN EXIT SUB
    IF RecSize%<1 THEN RecSize%=LEN(Rec$)
    FileHand%=FREEFILE
    OPEN "R",FileHand%,Fil$,RecSize%
      FIELD FileHand%, RecSize% AS Tmp$
      LSET Tmp$=REC$
      PUT FileHand%,RecNum%
    CLOSE FileHand%
END SUB

'GetRec - Get a record from a file

FUNCTION GetRec$(Fil$,RecNum%,RecSize%) PUBLIC

    a$=dir$(fil$)
    if a$="" then exit function
    IF RecNum%<1 THEN GetRec$="":EXIT FUNCTION
    FileHand%=FREEFILE
    OPEN "R",FileHand%,Fil$,RecSize%
      FIELD FileHand%, RecSize% AS Tmp$
      TotalRecs&=LOF(FileHand%)/RecSize%
      IF RecNum%<=TotalRecs& THEN GET FileHand%,RecNum%
      IF RecNum%>TotalRecs& THEN GetRec$="" ELSE GetRec$=Tmp$
    CLOSE FileHand%
END FUNCTION


'Expand - Expands a file to 13 charactors

FUNCTION Expand$(Filn$) PUBLIC
   IF Filn$="." OR Filn$=".." OR Filn$=".>" OR Filn$="..>" THEN
     Expand$=LEFT$(Filn$+SPACE$(12),12)
     EXIT FUNCTION
   END IF
   Dot%=INSTR(Filn$,".")
   IF Dot%=0 THEN
     Expand$=LEFT$(Filn$+SPACE$(12),12)
     EXIT FUNCTION
   END IF
   Tmp$=LEFT$(LEFT$(Filn$,Dot%-1)+"        ",8)+"."
   Expand$=LEFT$(Tmp$+MID$(Filn$,Dot%+1)+"   ",12)
END FUNCTION


'RenFile% - Renames a file (can also move a file on the same drive)

FUNCTION RenFile%(P1$,P2$) PUBLIC
  Tmp1$=P1$+CHR$(0)
  Tmp2$=P2$+CHR$(0)
  REG 1,&H5600
  REG 4,STRPTR(Tmp1$)
  REG 8,STRSEG(Tmp1$)
  REG 6,STRPTR(Tmp2$)
  REG 9,STRSEG(Tmp2$)
  CALL INTERRUPT &H21
  IF (REG(0) AND 1)=1 THEN renFile%=REG(1)
END FUNCTION





