$compile unit

$error all-
$lib all-

defint a-z

'-----------------------------------------------------------------------
'
' fnformattime$     formats a DOS time stamp into a string
'
' input parameters:
'
'    time%           DOS time stamp to be formatted
'
' function returns: time formatted as HH:MM:SS AM (11 character string)
'
' note that time stamp resolution is only 2 seconds
'
FUNCTION formattime$(time%)  PUBLIC
      local h%,m%,s%,i%
      local m$,x$

      if time%<0 then
         time% = time% and &h7FFF
         h% = 16
      else
         h% = 0
      end if
      h% = h%+time%\2048
      if h%>=12 then
         m$ = " PM"
         h% = h%-12
      else
         m$ = " AM"
      end if
      if h%=0 then h% = 12
      m% = (time%\32) mod 64
      s% = (time% mod 32)*2
      x$ = right$(str$(h%),2)+":"+right$(str$(m%),2)+":"+right$(str$(s%),2)+m$
      for i% = 2 to 8                    ' note: leave first leading blank
         if mid$(x$,i%,1)=" " then mid$(x$,i%,1) = "0"
      next i%
      formattime$ = x$
end fUNCTION