$compile unit

$error all-
$lib all-

defint a-z



'Ŀ
' SUBROUTINE MDY.to.Julian(month%,day%,year%,julian&,weekday%)               
'    Return JULIAN& date value for MONTH%-DAY%-YEAR%.  Also returns the      
'    WEEKDAY% (1=Sunday to 7=Saturday).  Allows date arithmetic.             
'

   SUB MDY.to.Julian(month%,day%,year%,julian&,weekday%)  Public
      LOCAL temp1%,temp2%,temp3%,temp4&
      julian&=FIX(365.2422#*year%+30.44*(month%-1)+day%+1)
      temp1%=month%-2-12*(month%<3)
      temp2%=year%+(month%<3)
      temp3%=FIX(temp2%/100)
      temp2%=temp2%-100*temp3%
      weekday%=FIX(2.61*temp1%-.2)+day%+temp2%+FIX(temp2%/4)
      weekday%=(weekday%+INT(temp3%/4)-temp3%-temp3%+77) MOD 7 + 1
      temp4&=julian&-7*FIX(julian&/7)
      julian&=julian&-temp4&+weekday%+7*(temp4&<weekday%-1)+1721060#
   END SUB



'Ŀ
' SUBROUTINE Julian.to.MDY(julian&,month%,day%,year%,weekday%)               
'    Returns MONTH%, DAY%, YEAR%, and WEEKDAY% (1=Sunday to 7=Saturday)      
'    for speicified date value JULIAN&.  Allows date arithmetic.             
'                                                                            
'    ***  This routine calls MDY.to.Julian - use both if using this  ***     
'

   SUB Julian.to.MDY(julian&,month%,day%,year%,weekday%)  Public
      LOCAL jtemp&,yr.temp%,wd.temp%
      yr.temp%=FIX((julian&-1721061#)/365.25+1)
      INCR yr.temp%
      DO
         DECR yr.temp%
         CALL MDY.to.Julian(1%,1%,yr.temp%,jtemp&,wd.temp%)
      LOOP WHILE jtemp&>julian&
      mo.temp%=FIX((julian&-jtemp&)/29+1)
      INCR mo.temp%
      DO
         DECR mo.temp%
         CALL MDY.to.Julian(mo.temp%,1%,yr.temp%,jtemp&,wd.temp%)
      LOOP WHILE jtemp&>julian&
      da.temp%=CINT(julian&-jtemp&+1)
      CALL MDY.to.Julian(mo.temp%,da.temp%,yr.temp%,jtemp&,wd.temp%)
      month%=mo.temp%
      day%=da.temp%
      year%=yr.temp%
      weekday%=wd.temp%
   END SUB