$compile unit

$error all-
$lib all-

defint a-z




' Numeric Manipulation Routines 

'Ŀ
' SUBROUTINE Any2Dec(anum$,nbase%,dnum%,errcode%)                          
'    Convert string ANUM$ representing a number in base NBASE% to decimal  
'    (base 10) number DNUM%.  ERRCODE% is true (-1) if NBASE% is less than 
'    2 or greater than 35, or ANUM$ is a null string.  Digits are 0 to Z.  
'

   SUB Any2Dec(anum$,nbase%,dnum%,errcode%)  Public
      LOCAL i%,d%,c$,digits$,negative%
      errcode%=-1
      dnum%=0
      IF nbase%<2 OR nbase%>35 THEN EXIT SUB
      IF anum$="" THEN EXIT SUB
      digits$="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
      negative%=(MID$(anum$,1,1)="-")
      FOR i%=1-negative% TO LEN(anum$)
         c$=MID$(anum$,i%,1) : d%=INSTR(digits$,c$)-1
         dnum%=nbase%*dnum%+d%
      NEXT
      IF negative% THEN dnum%=-dnum%
      errcode%=0
   END SUB


'Ŀ
' SUBROUTINE Dec2Any(dnum%,nbase%,anum$,errcode%)                         
'    Convert decimal (base 10) number DNUM% to string ANUM$ representing  
'    the number in base NBASE%.  ERRCODE% is true (-1) if NBASE% is less  
'    than 2 or greater than 35.  Digits are 0 to Z.                       
'

   SUB Dec2Any(dnum%,nbase%,anum$,errcode%)  Public
      LOCAL temp%,i%,digits$,negative%
      errcode%=-1
      anum$=""
      IF nbase%<2 OR nbase%>35 THEN EXIT SUB
      digits$="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
      negative%=(dnum%<0)
      temp%=ABS(dnum%)
      DO
         i%=(temp% MOD nbase%)
         anum$=MID$(digits$,i%+1,1)+anum$
         temp%=(temp% \ nbase%)
      LOOP UNTIL temp%=0
      IF negative% THEN anum$="-"+anum$
      errcode%=0
   END SUB


'Ŀ
' FUNCTION ShiftLeft%(ival%,bitshift%)                                    
'    Binary shift IVAL% left BITSHIFT% bits.   Equals IVAL%\(2^BITSHIFT%) 
'    except when treating IVAL% as an unsigned integer.  This function is 
'    for those programers who know why they can use it!                   
'

   Function ShiftLeft%(ival%,bitshift%)  Public
      LOCAL temp$
      ShiftLeft%=ival%
      IF bitshift%<0 OR bitshift%>16 THEN EXIT Function
      temp$=BIN$(ival%)+STRING$(bitshift%,"0")
      ShiftLeft%=VAL("&b"+RIGHT$(temp$,16))
   END Function


'Ŀ
' FUNCTION ShiftRight%(ival%,bitshift%)                                   
'    Binary shift IVAL% right BITSHIFT% bits.   Equals IVAL%*(2^BITSHIFT%)
'    except when treating IVAL% as an unsigned integer.  This function is 
'    for those programers who know why they can use it!                   
'

   Function ShiftRight%(ival%,bitshift%)  Public
      LOCAL temp$
      ShiftRight%=ival%
      IF bitshift%<0 OR bitshift%>16 THEN EXIT Function
      temp$=BIN$(ival%)
      WHILE LEN(temp$)<16 : temp$="0"+temp$ : WEND
      temp$=STRING$(bitshift%,"0")+temp$
      ShiftRight%=VAL("&b"+LEFT$(temp$,16))
   END Function

