$IF 0

 
                        Digitek Data Systems
                         1350 Birchcrest Blvd  Suite G
                      Port Charlotte, FL  33952
 
   THIS FILE: SETKBD.BAS
      AUTHOR: Erik Olson
 DESCRIPTION: Set shift states of the keyboard

 $ENDIF

' %TurnOff = 0
' %TurnOn  = NOT %TurnOff

'ins%  = %TurnOn
'caps% = %TurnOff
'num%  = %TurnOn
'sclk% = %TurnOff

'CALL SetKBD(ins%, caps%, num%, sclk%)

$compile unit

$error all-
$lib all-

defint a-z



SUB SetKBD(i%, c%, n%, s%) PUBLIC
   DEF SEG = 0
   Now% = PEEK(&H417)
   DEF SEG
   IF s% THEN Now% = Now% OR 16 ELSE _
                       Now% = Now% AND NOT 16
   IF n% THEN Now% = Now% OR 32 ELSE _
                       Now% = Now% AND NOT 32
   IF c% THEN Now% = Now% OR 64 ELSE _
                       Now% = Now% AND NOT 64
   IF i% THEN Now% = Now% OR 128 ELSE _
                       Now% = Now% AND NOT 128
   DEF SEG = 0
   POKE &H417, Now%
   DEF SEG


END SUB


'StuffKey - Stuffs one to 16 characters into the keyboard buffer

SUB StuffKey(Lin$) STATIC PUBLIC
  LOCAL TAIL,LOOPCOUNTER

  DEF SEG = &H40
  Tail = PEEK(&H1C)
	FOR LoopCounter = 1 TO LEN(Lin$)
      IF Tail > &H3C THEN Tail = &H1E
	    POKE Tail, ASC(MID$(Lin$, LoopCounter))
	    Tail = Tail + 2
	NEXT
	IF Tail > &H3C THEN Tail = &H1E
  POKE &H1C, Tail
	DEF SEG
END SUB


'CheckKey% - Check if a key is in the KB buffer without removing it

FUNCTION CheckKey% PUBLIC
   DEF SEG=&h40
   IF PEEK(&h1C)<>PEEK(&h1A) THEN CheckKey%=-1
   DEF SEG
END FUNCTION

'CapsOn - Turn caps lock on

SUB Caps.On STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) OR 64
  DEF SEG
END SUB

'CapsOff - Turn caps lock off

SUB Caps.Off STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) AND 191
  DEF SEG
END SUB

'NumOn - toggle number lock on

SUB Num.On STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) OR 32
  DEF SEG
END SUB

'NumOff - toggle number lock off

SUB Num.Off STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) AND 223
  DEF SEG
END SUB

'CapStat% - Returns the status of the caps lock key

FUNCTION Cap.Stat% PUBLIC
    DEF SEG=0
    CapStat%=PEEK(&H417) AND &H40
    DEF SEG
END FUNCTION

'NumStat% - Returns the status of the number lock key

FUNCTION Num.Stat% PUBLIC
    DEF SEG=0
    NumStat%=PEEK(&H417) AND &H20
    DEF SEG
END FUNCTION

'InsertOn - toggle insert key status

SUB Insert.On STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) OR 128
  DEF SEG
END SUB

'InsertOff - toggle insert mode off

SUB Insert.Off STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) AND 127
  DEF SEG
END SUB

'ScrollOn - toggle scroll lock on

SUB Scroll.On STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) OR 16
  DEF SEG
END SUB

'ScrollOff - toggle scroll lock off

SUB Scroll.Off STATIC PUBLIC
  DEF SEG = 0
	POKE &H417,PEEK(&H417) AND 239
  DEF SEG
END SUB

'IsAlt% - Determines if alt key is being pressed

FUNCTION Is.Alt% PUBLIC
   DEF SEG = 0
   IsAlt% = (PEEK(&H417) AND 8) = 8
   DEF SEG
END FUNCTION

'IsCtrl% - Determines if ctrl key is being pressed

FUNCTION Is.Ctrl% PUBLIC
   DEF SEG = 0
   IsCtrl% = (PEEK(&H417) AND 4) = 4
   DEF SEG
END FUNCTION

'IsLShift% - Determines if left shift is being pressed

FUNCTION Is.LShift% PUBLIC
   DEF SEG = 0
   IsLShift% = (PEEK(&H417) AND 2) = 2
   DEF SEG
END FUNCTION

'IsRShift% - Determines if right shift is being pressed

FUNCTION Is.RShift% PUBLIC
   DEF SEG = 0
   IsRShift% = (PEEK(&H417) AND 1) = 1
   DEF SEG
END FUNCTION

'IsInsert% - Determines if insert is being pressed

FUNCTION Is.Insert% PUBLIC
   DEF SEG = 0
   IsInsert% = (PEEK(&H418) AND 128) = 128
   DEF SEG
END FUNCTION

'IsCaps% - Determines if caps lock is being pressed

FUNCTION Is.Caps% PUBLIC
   DEF SEG = 0
   IsCaps% = (PEEK(&H418) AND 64) = 64
   DEF SEG
END FUNCTION

'IsNumLock% - Determines if num lock is being pressed

FUNCTION Is.NumLock% PUBLIC
   DEF SEG = 0
   IsNumLock% = (PEEK(&H418) AND 32) = 32
   DEF SEG
END FUNCTION

'IsScroll% - Determines if scroll lock is being pressed

FUNCTION Is.Scroll% PUBLIC
   DEF SEG = 0
   IsScrollLock% = (PEEK(&H418) AND 16) = 16
   DEF SEG
END FUNCTION

'InsStat% - returns insert status

FUNCTION Ins.Stat% PUBLIC
   DEF SEG = 0
   InsStat% = (PEEK(&H417) AND 128) = 128
   DEF SEG
END FUNCTION

'ScrollStat% - returns scroll lock status

FUNCTION Scroll.Stat% PUBLIC
   DEF SEG = 0
   ScrollStat% = (PEEK(&H417) AND 16) = 16
   DEF SEG
END FUNCTION