' System Status Routines 

'Ŀ
' SUBROUTINE GetSystemTime(hours%,minutes%,seconds%)                         
'    Returns the current system time (24-hour format).                       
'

   SUB GetSystemTime(hours%,minutes%,seconds%)  Public
'forget about 100ths of seconds!
      REG 1,&h2C00
      CALL INTERRUPT &h21
      hours%=(REG(3) \ 256)
      minutes%=(REG(3) AND &hFF)
      seconds%=(REG(4) \ 256)
   END SUB


'Ŀ
' FUNCTION VideoClass%                                                       
'   Check BIOS area for installed monitor class.  Returns 0 for monochrome,  
'   1 for color (CGA) and 2 if either an EGA or VGA was found and is the     
'   active monitor.  If more specific information is needed (for Hercules,   
'   Compaq, or actual VGA) use FnVideoAdapter$.                              
'

   Function VideoClass%  Public
      LOCAL byte%
      VideoClass%=0                               ' set initially to MDA
      REG 1,&h0F00                                  ' GetCurrentMode function
      CALL INTERRUPT &h10                           ' VideoBios call
      byte%=(REG(1) AND &hFF)                       ' current video mode
      IF byte%<>7 THEN
         VideoClass%=1                            ' next step is CGA
         DEF SEG=&h40                               ' ROM BIOS info area
         byte%=PEEK(&h87)                           ' check for EGA/VGA
         IF byte%<>0 THEN
            IF (byte% AND 8)=0 THEN VideoClass%=2 ' if active, say so!
         END IF
         DEF SEG
      END IF
   END Function


'Ŀ
' FUNCTION VideoAdapter$                                                     
'    Returns first letter of Mono, CGA, EGA, VGA, Hercules, or returns       
'    Q for Compaq or O for Other (unidentified) monitor.  For a more gen-    
'    eral determination, see FnVideoClass% (above).                          
'

   Function VideoAdapter$  Public
      LOCAL ps2%,vga%,ega.info%,vadapt%,vmode%,i%
      LOCAL desc%,string.seg%,string.off%
      LOCAL types$,buffer$
' Start by attempting a PS/2-only VideoState request --
      buffer$=SPACE$(64)                          ' buffer for VideoState call
      DEF SEG
      string.seg%=PEEK(0)+256*PEEK(1)             ' Turbo BASIC string segment
      DEF SEG=VARSEG(buffer$)                     ' switch to string segment
      desc%=VARPTR(buffer$)                       ' 2-byte len, 2-byte offset
      string.off%=PEEK(desc%+2)+256*PEEK(desc%+3) ' offset for buffer$
      DEF SEG
      REG 9,string.seg%                           ' ES - segment of buffer
      REG 6,string.off%                           ' DI - offset of buffer
      REG 1,&h1B00                                ' AH - function code 1B
      REG 2,&h0                                   ' BX - type code
      CALL INTERRUPT &h10                         ' call video BIOS interrupt
      ps2%=((REG(1) AND &hFF)=&h1B)               ' call only valid for PS/2
      vga%=0
' If it is a PS/2, check for the old Model 30 MCGA
      IF ps2% THEN
         REG 1,&h1A00                             ' AH=1A (fnc), AL=00 (read)
         CALL INTERRUPT &h10                      ' call video BIOS again
         code%=(REG(2) AND &hFF)                  ' active display code in BL
         IF code%=7 OR code%=8 THEN vga%=-1       ' either VGA monitor code
      END IF
      IF ps2% AND vga% THEN
         types$="V"                                ' not Model 30 MCGA
      ELSE
' Get various system information about video
         CALL INTERRUPT &h11                      ' GetEquipmentList call
         vadapt%=((REG(1) AND &h0030)\16)         ' isolate bits 4 & 5 of AX
         REG 1,&h0F00                             ' GetCurrentMode function
         CALL INTERRUPT &h10                      ' VideoBios call
         vmode%=(REG(1) AND &hFF)                 ' current video mode
         DEF SEG=&h40                             ' BIOS info in RAM
         ega.info%=PEEK(&h87)                     ' EGA information byte
         DEF SEG
         types$="O"
         IF ega.info%<>0 THEN
            types$="E"
         ELSE
            SELECT CASE vadapt%
               CASE 3
' IBM MDA or Herc --
' During vertical retrace Hercules strobes the high bit, IBM doesn't
                  old%=(INP(&h3BA) AND &h80)
                  FOR i%=0 TO &h1000
                     new%=(INP(&h3BA) AND &h80)     ' check status register
                     IF old%<>new% THEN             ' for a change in the
                        types$="H"                   ' high bit
                        EXIT FOR
                     END IF
                  NEXT
                  IF types$="O" THEN
                     types$="M"
                  END IF
               CASE 0, 2
' IBM CGA or Compaq --
' IBM normally boots in Mode 3, Compaq in 2
                  IF vmode%=2 THEN
                     types$="Q"
                  ELSE
                     types$="C"
                  END IF
               CASE ELSE
            END SELECT
         END IF
      END IF
      VideoAdapter$=types$
   END Function


'Ŀ
' SUBROUTINE AdapterList(parallel%,serial%,game%)                            
'    Returns the number of parallel and serial ports installed.              
'    GAME% will be true (-1) if a game/joystick port is installed.           
'

   SUB AdapterList(parallel%,serial%,game%)  Public
      LOCAL temp%,temp$
      CALL INTERRUPT &h11
' returns unsigned integer -- use binary string
      temp$=RIGHT$(STRING$(16,"0")+BIN$(REG(1)),16)
      temp%=VAL("&b"+MID$(temp$,1,8))
      parallel%=(temp%\64)
      serial%=((temp%\2) AND 7)
      game%=((temp% AND 16)=16)
   END SUB


'Ŀ
' FUNCTION Is8087%                                                           
'    Returns true (-1) or false (0) indicating an 8087 or 80287 installed.   
'    Is not be accurate if dip switch set, but chip not there (hey...).      
'

   Function Is8087%  Public
      CALL INTERRUPT &h11
      Is8087%=((REG(1) AND 2)=2)
   END Function